//modified by Jing Yang after 7/6/2001
#include "ogl.H"
#include "CSunburstDimDisplay.H"
#include "XmdvTool.H"
#include "colormap.H"
#include "magnify.H"
#include "brush_oper.H"
#include "CDimReducer.H"

CSunburstDimDisplay::CSunburstDimDisplay() : CSunburstDisplay()
{
//    tree = GetTree();
}


CSunburstDimDisplay::~CSunburstDimDisplay()
{
}


CSunburstClusterTree* CSunburstDimDisplay::GetTree()
{
    if ( dtree )
        return dtree;

    if ( ! dim_reducer )
    dim_reducer = new CDimReducer();

    dtree = dim_reducer->GetDimClusterTree();
    return dtree;
}


void CSunburstDimDisplay::SunburstCaption(int x, int y)
{
    current_node = FindNode(x, y);
	if ( current_node == NULL )
//		appShowSunburstCaption(Togl_Interp(canvas->GetWidget()),"");
        appShowCanvasMessage(Togl_Interp(canvas->GetWidget()),"", canvas->name);
	else
	{    
		char stri[100];   
		strcpy(stri, ((CSunburstDimCluster *)current_node)->dim_name);
//		appShowSunburstCaption(Togl_Interp(canvas->GetWidget()), stri);
        appShowCanvasMessage(Togl_Interp(canvas->GetWidget()),stri, canvas->name);
	}
}


void CSunburstDimDisplay::InputMouseMotion(int x, int y)
{
    if (!tree) return;

    if ( screen_distortion->distortion_status == true )
    {
		near_mouse_mode = INACTIVE;

		if (mouse_mode == INACTIVE) 
		{
	        current_node = FindNode(x, y, start_node, end_node, in_node);

			if ( current_node != NULL )
			{
				if ( start_node )
				{
					canvas->SetCursor("right_side");
					near_mouse_mode = LEFT_DISTORTION_HANDLE;
				}
				else if ( end_node )
				{
					canvas->SetCursor("left_side");
					near_mouse_mode = RIGHT_DISTORTION_HANDLE;
				}
				else if ( in_node )
				{
//					canvas->SetCursor("sb_h_double_arrow");
					canvas->SetDefaultCursor();
					near_mouse_mode = MIDDLE_DISTORTION;
				}
				else 
				{
					canvas->SetDefaultCursor();
				}
			}

		}
		else
		{
			if (canvas->button[0] != true) return;

			double angle;
			switch(mouse_mode) {
			case LEFT_DISTORTION_HANDLE:
				if ( GetAngleAccordingXY(x, y, angle) )
					current_node->ChangeSweepAngle(true, angle, dtree->mini_angle); 
				appRefreshAllCanvas(Togl_Interp(canvas->GetWidget()));
				return;

			case RIGHT_DISTORTION_HANDLE:
				if ( GetAngleAccordingXY(x, y, angle) )
					current_node->ChangeSweepAngle(false, angle, dtree->mini_angle); 
				appRefreshAllCanvas(Togl_Interp(canvas->GetWidget()));
				return;

			case MIDDLE_DISTORTION: {
				appRefreshAllCanvas(Togl_Interp(canvas->GetWidget()));
				}

			default:
				break;
			}
		}
    }
    else if ( dim_reducer->status == MODIFY )
    {
    	if (canvas->button[0] == true && prev_node != NULL) 
        {
            canvas->SetCursor("hand2");
    		SunburstCaption(x, y);
        }
        else
        {
    		canvas->SetDefaultCursor();
    		SunburstCaption(x, y);
        }
    }
	else
	{
		canvas->SetDefaultCursor();
		SunburstCaption(x, y);
	}
}


void CSunburstDimDisplay::InputButtonPress(int button, int x, int y)
{
    if (!tree) return;

    if ( screen_distortion->distortion_status == true )
    {
	    if ( button == 0 )
	    {
//		    if ( screen_distortion->distortion_status )
		    {
			    if (near_mouse_mode!=INACTIVE) mouse_mode = near_mouse_mode;

			    InputMouseMotion(x, y);
		    }
	    }
    }
    else if ( dim_reducer->status == NORMAL )
    {
	 /*   if ( button == 2 )
	    {
	        y = Togl_Height(canvas->GetWidget()) - y - 1;
		    
		    char str[100];
		    sprintf(str, " %d %d ", x, y);

            Tcl_VarEval(Togl_Interp(canvas->GetWidget()), "PopSunburstRightMenuDialog ", str, 0);
	    } */
    }
    else if ( dim_reducer->status == SELECT )
    {
        if ( button == 0 )
        {
            current_node = FindNode(x, y);
            if ( current_node == NULL )
                return;
            if ( current_node->selected == false )
            {
                current_node->selected = true;
                dim_reducer->AddRepresentativeDim((CSunburstDimCluster *)current_node);
    		    char stri[100];   
	    	    strcpy(stri, ((CSunburstDimCluster *)current_node)->dim_name);
	    	    strcat(stri, " has been selected!");
//		        appShowSunburstCaption(Togl_Interp(canvas->GetWidget()), stri);
                appShowCanvasMessage(Togl_Interp(canvas->GetWidget()),stri, canvas->name);
            }
            else
            {
                current_node->selected = false;
                dim_reducer->DeleteRepresentativeDim((CSunburstDimCluster *)current_node);
    		    char stri[100];   
	    	    strcpy(stri, ((CSunburstDimCluster *)current_node)->dim_name);
	    	    strcat(stri, " has been unselected.");
//		        appShowSunburstCaption(Togl_Interp(canvas->GetWidget()), stri);
                appShowCanvasMessage(Togl_Interp(canvas->GetWidget()),stri, canvas->name);
            }
            canvas->Refresh();
        }
	    else if ( button == 2 )
	    {
            current_node = FindNode(x, y);
            if ( current_node == NULL )
                return;

            dim_reducer->current_node = (CSunburstDimCluster *)current_node;

/*          int entries = current_node->GetEntries();
            y = Togl_Height(canvas->GetWidget()) - y - 1;
		    
		    char str[100];
		    sprintf(str, " %d %d %d", x, y, entries);
*/          
			double radius = current_node->GetRadius();
            y = Togl_Height(canvas->GetWidget()) - y - 1;
		    
		    char str[100];
		    sprintf(str, " %d %d %lf", x, y, radius);

            Tcl_VarEval(Togl_Interp(canvas->GetWidget()), "PopSunburstRightMenuDialog ", str, 0);
	    } 
    }   
    else if ( dim_reducer->status == MODIFY )
    {
        if ( button == 0 )
        {
            prev_node = current_node = FindNode(x, y);
            if ( current_node == NULL )
                return;
            if ( prev_node->parent == NULL )
            {
                prev_node = NULL;
                return;
            }
            canvas->SetCursor("hand2");
	    } 
    }   
}

void CSunburstDimDisplay::InputButtonRelease(int button, int x, int y)
{
    if (!tree) return;

    if ( screen_distortion->distortion_status == true )
    {
        if ( current_node != NULL )
        {
            if ( button == 2 )
	        {
			    if ( near_mouse_mode == MIDDLE_DISTORTION )
                {
                    if ( current_node->show_children == true )
                    
                        current_node->show_children = false;
                    else 
                        current_node->show_children = true;
                }
	        }
        }
        else
        {
            if ( button == 0 )
                GetTree()->Rotate(5.);
            else if ( button == 2 )
                GetTree()->Rotate(-5.);
        }
        //dtree->ResetLevels();
        canvas->Refresh();
    }
    else if ( dim_reducer->status == MODIFY )
    {
        current_node = FindNode(x, y);
        if ( current_node != NULL && current_node->children != NULL && button == 0 && prev_node != NULL) 
        {
            prev_node->parent->RemoveChild(prev_node);
            current_node->AddChild(prev_node);
            dtree->ResetEntries();
            dtree->ResetLevels();
            dtree->ResetAngles();

            canvas->Refresh();
        }
    	canvas->SetDefaultCursor();
    	SunburstCaption(x, y);
	}
    near_mouse_mode = mouse_mode = INACTIVE;
	InputMouseMotion(x, y);
}


void CSunburstDimDisplay::DrawSingleClusterName(CSunburstCluster *node)
{
    if ( ! node->selected )
        return;
    canvas->SetForeground(interface_color[TEXT]);
    double mid_ang = node->GetMidAngle();
    double radi = (radius[node->level-1] + radius[node->level])/2.0;
	Vec2 p1 = MapData(radi, mid_ang);

    CSunburstDimCluster *cluster = (CSunburstDimCluster *)node;
    char buf[50];
    sprintf(buf, "%s", cluster->dim_name);
    canvas->DrawConfinedString(p1.X, p1.Y, buf, 1);

}


