//modified by Jing Yang after 7/6/2001

#include "XmdvTool.H"
#include "macros.H"
#include "ogl.H"
#include "okcdata.H"
#include "cluster.H"
//jing
#include "brush.H"
#include "brush_oper.H"
#include "magnify.H"
#include "multi_select.H"
#include <iostream.h> 
//jing
//#include <unistd.h>
//jing
#include <stdlib.h>
#include <sys/stat.h>
#include <string.h>
#include <stdio.h>
#include "stats.H"
#include "X11/keysym.h"

#include "CFlatParcoord.H"
#include "CFlatScatter.H"
#include "CFlatDimstack.H"
#include "CFlatGlyph.H"
#include "CParcoordTool.H"
#include "CGlyphTool.H"
#include "CDimstackTool.H"
#include "CHierParcoord.H"
#include "CHierScatter.H"
#include "CHierGlyph.H"
#include "CHierDimstack.H"
#include "CHierNav.H"
#include "CHierHist.H"
#include "CHierTreemap.H"

#include "CSunburstDimDisplay.H"
#include "CSunburstDimClusterTree.H"

#include "CSunburstDataDisplay.H"
#include "CSunburstDataClusterTree.H"

#include "OnlineDataClustering.H"

/* SID */
#include "./backend_fake/db_buffer.h"
#include "./backend_fake/db_clock.h"
#include "./backend_fake/db_prefetch.h"
#include "./backend_fake/db_connect.h"
#include "./backend_fake/db_GLOBAL.h"

#ifdef _WIN32
#define strcasecmp stricmp
#endif

int DSIZE = 1;
struct okcdata *dataset = 0;
unsigned long interface_color[NUM_INTERFACE_ITEM];
char oldType[50];
CFlatDisplayInformation* flat_info;
CHierDisplayInformation* hier_info;
CDimReductionDisplayInformation* dim_reduction_info;
CScreenDistortion* screen_distortion;
CSunburstDimClusterTree* dtree;
CDimReducer* dim_reducer;
HistMgmt* histMgmt;	//YK
//new change
char* default_file_name;

static char interface_file[200];


/* SID */
typedef struct {
  int time;
  int type;
  double value;
  Tcl_Interp *interp;
} TestData;

/* SID */
int Prefetcher=1;
int BrushSemantic=0;		/* ALL = 0, ANY = 1, ... */
int Prefetch_Strategy=1;		/* Random = 1, Direction = 2, focus = 3, no = 0*/

bool backend = false;


/* Jing SID */
//these two functions take place of appSetBackend, with username and password as parameters. Jing
static int appConnectDatabase(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    //Punit, add your new function here.
	if ( 1 )
    {
		backend = true;
		hier_info->SetBackend(backend);
		if ( dataset && btree && hier_info->database )
		{
			/* SID */
			init_memory(dataset->datafile);
		}

		appRefreshAllCanvas(interp);
	    Tcl_VarEval(interp, "ShowCaption \"","Connected to the database successfully. \"", 0);
    }
	else
	{
	    Tcl_VarEval(interp, "ShowCaption \"","Connection failed. \"", 0);
	}
    return TCL_OK;
}

static int appDisconnectDatabase(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
	if ( backend == true )
	{
		backend = false;
		destroyBackendConnectivity();
		hier_info->SetBackend(backend);
		appRefreshAllCanvas(interp);
	}

    return TCL_OK;
}

static int appSetBackend(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    if ( atoi(argv[1]) )
	{
		if ( backend == false )
		{
			backend = true;
			db_connect_to_database("xmdv@kenny.wpi.edu", "xmdv");
			hier_info->SetBackend(backend);
			if ( dataset && btree && hier_info->database )
			{
				/* SID */
				init_memory(dataset->datafile);
			}

		    appRefreshAllCanvas(interp);
//			if ( dataset )
//	        Tcl_VarEval(interp, "appLoadOkcFile ", dataset->datafile, 0);

			/*
			Tcl_VarEval(interp, "SetPrefetcher ", "1", 0);
			Tcl_VarEval(interp, "appLoadOkcFile ", "data/synt2k.okc", 0);

			Tcl_VarEval(interp, "SetupDataSummary", 0);
			Tcl_VarEval(interp, "ResetDisplayModes", 0);
			Tcl_VarEval(interp, "SelectDisplayMode ", "parcoord", 0);
			Tcl_VarEval(interp, "SelectDisplayMode ", "hierarchical", 0);
			Tcl_VarEval(interp, "Window show [W ClusterHierarchyDialog]", 0);
			Tcl_VarEval(interp, "raise [W ClusterHierarchyDialog]", 0);
			Tcl_VarEval(interp, "appTest", 0);
*/		}
	}
	else 
	{
		if ( backend == true )
		{
			backend = false;
			hier_info->SetBackend(backend);
		    appRefreshAllCanvas(interp);
	//			if ( dataset )
//	        Tcl_VarEval(interp, "appLoadOkcFile ", dataset->datafile, 0);
//			Tcl_VarEval(interp, "appCloseOkcFile", 0);

		}
	}

    return TCL_OK;
}


static int appStartBackendDemo(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
//	if ( backend == true )
	{
	//	Tcl_VarEval(interp, "SetPrefetcher ", "1", 0);
//		Tcl_VarEval(interp, "appLoadOkcFile ", "data/synt2k.okc", 0);
		
//		hier_info->SHOW_BANDS = false;
		
	//	Tcl_VarEval(interp, "SetupDataSummary", 0);
		Tcl_VarEval(interp, "ResetDisplayModes", 0);
//		Tcl_VarEval(interp, "SelectDisplayMode ", "parcoord", 0);
		Tcl_VarEval(interp, "SelectDisplayMode ", "hierarchical", 0);
		Tcl_VarEval(interp, "Window show [W ClusterHierarchyDialog]", 0);
		Tcl_VarEval(interp, "raise [W ClusterHierarchyDialog]", 0);
		Tcl_VarEval(interp, "appTest", 0);
	}

    return TCL_OK;
}


/* SID */
static int appSetPrefetcher(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    Prefetcher = atoi(argv[1]);
    return TCL_OK;
}

/* SID */
static int appSetBrushSemantic(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    BrushSemantic = atoi(argv[1]);
	SetupBrushParameters();
    appRefreshAllCanvas(interp);
    return TCL_OK;
}

static int appSetPrefetchStrategy(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    Prefetch_Strategy = atoi(argv[1]);
    return TCL_OK;
}


/* SID */
int appStartPrefetcher(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
        start_prefetcher();
        return TCL_OK;
}

/* SID */
int appStopPrefetcher (ClientData clientdata, Tcl_Interp *interp, int argc, char *argv[])
{
        stop_prefetcher();
        return TCL_OK;
}

/* SID */
int appDisplayTime(ClientData clientdata, Tcl_Interp *interp, int argc, char *argv[])
{
//	display_time();
	return TCL_OK;
}

/* SID */
int appSaveActiveSet (ClientData clientdata, Tcl_Interp *interp, int argc, char *argv[])
{
        save_active_set();
        return TCL_OK;
}

/* SID */
int appRegisterChange (ClientData clientdata, Tcl_Interp *interp, int argc, char *argv[])
{
        register_change();
        return TCL_OK;
}

/* SID */
//YS
//here I added comments and one more handler
//please copy complete function
static void appOneChange(ClientData clientData)
{
    TestData *data = (TestData *)clientData;

/*
    if (DISPLAY_DEBUG)
    {
	printf("EXEC type=%d value=%lf\n", data->type, data->value);
	fflush(stdout);
    }
*/
    stop_prefetcher();

	//1 means left extent
    if (data->type == 1)
    {
	save_active_set();
	hier_info->tree_brush[0] = data->value;
	register_change();
    appUpdateTreeBrushEntries(data->interp);
        SetupBrushParameters();
        appRefreshAllCanvas(data->interp);
    }

	//2 means right extent
    else if (data->type == 2)
    {
	save_active_set();
	hier_info->tree_brush[1] = data->value;
	register_change();
    appUpdateTreeBrushEntries(data->interp);
        SetupBrushParameters();
        appRefreshAllCanvas(data->interp);
    }

	//3 is changing the level of detail for brushed region
    else if (data->type == 3)
    {
	save_active_set();
	char value[16];
	sprintf(value, "%lf", data->value);
	Tcl_VarEval(data->interp, "SetBrushedRadius ", value, 0);
	register_change();
	appUpdateClusterRadiusSliders(data->interp);
    }

	//4 is changing the level of detail for the unbrushed region
    else if (data->type == 4)
    {
	save_active_set();
	char value[16];
	sprintf(value, "%lf", data->value);
	Tcl_VarEval(data->interp, "SetClusterRadius ", value, 0);
	register_change();
	appUpdateClusterRadiusSliders(data->interp);
    }

	//6 is moving the middle brush (must update both left and right)
    else if (data->type == 6)
    {
	save_active_set();
	hier_info->tree_brush[0] += data->value;
	hier_info->tree_brush[1] += data->value;
	register_change();
    appUpdateTreeBrushEntries(data->interp);
        SetupBrushParameters();
        appRefreshAllCanvas(data->interp);
    }
	//5 means stop
    else if (data->type == 5)
    {
//	display_time();
    free(data);
	return;
//	Tcl_VarEval(data->interp, "appCloseOkcFile", 0);
//	exit(0);
    }

    if (Prefetcher) start_prefetcher();
//    if (DISPLAY_DEBUG) puts("DONE");

    free(data);
}
//YE

/* SID */
static int appTest(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    TestData *data;
    FILE *file = fopen("simulation/input","r");

	//jing 
//	reset_op_timer();
    
//	start_timer();

    for(;;)
    {
	data = new TestData;
	if (fscanf(file, "%d %d %lf",
		&(data->time), &(data->type), &(data->value)) <= 0) break;
	data->interp = interp;
	Tcl_CreateTimerHandler(data->time, appOneChange, data);
    }

    fclose(file);
    return TCL_OK;
}


static void appInitGlobals()
{
    dataset = 0;
    interface_color[BG] = 0xffffff;
    interface_color[TEXT] = 0x000000;
    interface_color[DATA] = 0x61f369;
    interface_color[HIGHLIGHT1] = 0xf20000;
    interface_color[HIGHLIGHT2] = 0xf2f200;
    interface_color[HIGHLIGHT3] = 0x00f2f2;
    interface_color[HIGHLIGHT4] = 0x0000f2;
    interface_color[OVERLAP] = 0x000000;
    interface_color[PAINT] = 0x980098;
    interface_color[GRID1] = 0xff0f0f;
    interface_color[GRID2] = 0x0fff0f;
    interface_color[GRID3] = 0x0f0fff;
    interface_color[GRID4] = 0x0f0fff;
    interface_color[STAT1] = 0x0000ea;
    interface_color[STAT2] = 0xc30000;
    interface_color[BRUSH1] = 0xafafea;
    interface_color[BRUSH2] = 0xafafaf;
    interface_color[BRUSH3] = 0xafaf75;
    interface_color[BRUSH4] = 0xafaf3a;
    interface_color[SBB] = 0xff7138;
}

static int appSetupDataValuesDialog(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    if (!dataset) return TCL_OK;

    Tcl_VarEval(interp, "[W DataValuesText] conf -state normal",0);
    Tcl_VarEval(interp, "[W DataValuesText] delete 0.0 end",0);

    char buf[500];
    char str[50000];
    int i;
    strcpy(str,"Oper: ");
    for (i=0;i<dataset->dims;i++) {         
        strcpy(buf,dataset->names[i]);
        buf[12] = '\0';
        sprintf(str,"%s %12s",str,buf);
    }
    strcat(str,"\n");
    Tcl_VarEval(interp, "[W DataValuesText] insert end \"",str,"\"",0);

//    char sep[strlen(str)+1];
//jing
    char* sep = new char[strlen(str)+1];
//jing
    for (i=0;i<(int)strlen(str);i++) sep[i]='-';
    sep[strlen(str)-1] = '\0';
    strcat(sep,"\n");
    Tcl_VarEval(interp, "[W DataValuesText] insert end \"",sep,"\"",0);

    int count = 0;
    for (int op=0; op<num_oper; op++)
    {
        // check if the operation has OPER_VALUES set
        if (!(brush_ops[op].oper & VALUES)) continue;

        ARR<double> data(dataset->dims);
        for (int i=0; i<dataset->data_size; i++)
        {
            dataset->GetData(data, i);
            if (BrushOperCheckPoint(data, op))
            {
                sprintf(str, "%4d: ", op+1);
                for (int j=0; j<dataset->dims; j++)
                {
                    sprintf(str, "%s %12.3f",str,data[j]);
                }
                strcat(str,"\n");
                Tcl_VarEval(interp, "[W DataValuesText] insert end \"",str,"\"",0);
                count++;
            }
        }

        // Check if we should add an average too
        if (brush_ops[op].oper & AVERAGE)
        {
            if (BrushOperCompAverage(op, data)==0) continue;

            sprintf(str, "Avg%d: ", op+1);
            for (int j=0; j<dataset->dims; j++)
            {
                sprintf(str, "%s %12.3f",str,data[j]);
            }
            strcat(str,"\n");
            Tcl_VarEval(interp, "[W DataValuesText] insert end \"",str,"\"",0);
        }
    }

    Tcl_VarEval(interp, "[W DataValuesText] insert end \"",sep,"\"",0);

    sprintf(str,"Total number of brushed data points = %d\n",count);
    Tcl_VarEval(interp, "[W DataValuesText] insert end \"",str,"\"",0);

    Tcl_VarEval(interp, "[W DataValuesText] conf -state disabled",0);
//jing
	delete sep;
//jing
    return TCL_OK;
}


// modified by jing yang. Now it not only refresh all the canvas, but also updata some dialogs. 
void appRefreshAllCanvas(Tcl_Interp *interp, grCanvas *except_this)
{
    Tcl_Eval(interp,"SetupDataValuesDialog");

    grCanvas *canvas = grFindCanvas(interp,"mainCanvas");
    assert(canvas);
    if (canvas!=except_this) canvas->Refresh();

    grCanvas *nav = grFindCanvas(interp,"structBrushCanvas");
    if (nav && nav!=except_this) nav->Refresh();

    grCanvas *sunburst = grFindCanvas(interp,"sunburstCanvas");
    if (sunburst && sunburst!=except_this) 
    {
        if ( dim_reduction_info->enable )
            sunburst->Refresh();
    }
    grCanvas *parcoordtool = grFindCanvas(interp,"minimapCanvas");
    if (parcoordtool && parcoordtool!=except_this) parcoordtool->Refresh();

    grCanvas *hist = grFindCanvas(interp,"histoCanvas");
    if (hist && hist!=except_this) hist->Refresh();

    grCanvas *treemap = grFindCanvas(interp,"treemapCanvas");
    if (treemap && treemap!=except_this) treemap->Refresh();

    grCanvas *glyphtool = grFindCanvas(interp,"glyphToolboxCanvas");
    if (glyphtool && glyphtool!=except_this) glyphtool->Refresh();

    grCanvas *stacktool = grFindCanvas(interp,"stackToolboxCanvas");
    if (stacktool && stacktool!=except_this) stacktool->Refresh();

    grCanvas *aux = grFindCanvas(interp,"auxillaryDisplayCanvas");
    if (aux && aux!=except_this) aux->Refresh();

    char str[50];   
	strcpy (str, "wm state [W DataSummaryDialog]");
    Tcl_Eval(interp, str);
    if (strcmp(interp->result,"normal")==0)
        appSetupBrushStatistics(interp);

}

static int appMainCanvasRefresh(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    grCanvas *canvas = grFindCanvas(interp,"mainCanvas");
    assert(canvas);
    canvas->Refresh();
    return TCL_OK;
}

static int appRefreshAllCanvas(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    appRefreshAllCanvas(interp);
    return TCL_OK;
}

void appCanvasInputKeyPress(grCanvas *canvas, int key)
{
    if (canvas->shiftkey) {
        // Go into multiselect mode
        multiSelectSetState(canvas,true);
        return;
    } else
    if (canvas->controlkey && curr_brush->bound_type == Brush::RAMP) {
        canvas->SetCursor("right_ptr");
    }

    switch (key) {
        case 'z': case 'Z':
            MagnifyBrushRegion(canvas);
            break;

        case 'a': case 'A':
            Demagnify(canvas);
            break;

        case 'e': case 'E':
            DSIZE++;
            DSIZE = CLAMP(DSIZE,1,10);
            canvas->Refresh();
            break;

        case 'r': case 'R':
            DSIZE--;
            DSIZE = CLAMP(DSIZE,1,10);
            canvas->Refresh();
            break;
        default: break;
    }
}

void appCanvasInputKeyRelease(grCanvas *canvas, int key)
{
    if (key == XK_Shift_L || key == XK_Shift_R) {
        // Exit multiselect mode
        multiSelectSetState(canvas,false);
        return;
    }
    canvas->SetDefaultCursor();
}

static int appSetDoubleBuffer(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    if ( atoi(argv[1]) )
        grCanvas::doublebuffer = true;
    else 
        grCanvas::doublebuffer = false;
//    grCanvas::doublebuffer = atoi(argv[1]);
    return TCL_OK;
}


//jingdelete
static int appSetCanvasZoom(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    double zoom = (atof(argv[2])-1)/40. + 1;

    grCanvas *canvas = grFindCanvas(interp, argv[1]);
    assert(canvas);

    canvas->zoom.X = canvas->zoom.Y = zoom;
    canvas->Refresh();

    return TCL_OK;
}

static int appSetCanvasZoomOneDirection(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    double zoom = atof(argv[2]);
    int direct = atoi(argv[3]);
    int mode = atoi(argv[4]);

    grCanvas *canvas = grFindCanvas(interp, argv[1]);

    if ( canvas == NULL )
        return TCL_OK;

    if ( mode == 0 )
    {
        zoom /= 100.;
        if ( zoom <= 0 )
            return TCL_OK;
        if ( direct == 0 )
        {
            canvas->zoom.X = zoom;
            canvas->Refresh();
        }
        else
        {
            canvas->zoom.Y = zoom;
            canvas->Refresh();
        }
    }
    else
    {
        if ( direct == 0 )
        {
            canvas->zoom.X *= zoom;
            canvas->Refresh();
        }
        else
        {
            canvas->zoom.Y *= zoom;
            canvas->Refresh();
        }
    }
    return TCL_OK;
}


static int appGetCanvasZoomOneDirection(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    int direct = atoi(argv[2]);

    grCanvas *canvas = grFindCanvas(interp, argv[1]);

    if ( canvas == NULL )
        return TCL_OK;

    double zoom;

    if ( direct == 0 )
        zoom = canvas->zoom.X;
    else
        zoom = canvas->zoom.Y;

    zoom *= 100;
    char str[5];
    sprintf(str,"%.0lf",zoom);
    Tcl_SetResult( interp, str, TCL_STATIC );
    return TCL_OK;
}

static int appDependentDimensionHasChanged(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    int which = atoi(argv[1]) - 1;
    if (dep_dim == which) return TCL_OK;

    dep_dim = which;
    grCanvas *canvas = grFindCanvas(interp,"treemapCanvas");
    assert(canvas);
    cfTreeMapInit();
    canvas->display->CanvasDraw();

    canvas->Refresh();

    return TCL_OK;
}

void appCanvasBrushHasChanged(Tcl_Interp *interp)
{
    if (dataset) BrushOperMarkDataset();
//    if (btree) hierModifyExtentsByBrushParameters();

}

/*
void appShowCaption(Tcl_Interp *interp, const char *str)
{
//jing
    char stri[50];   
	strcpy(stri, "ClearCaption");
	Tcl_Eval(interp, stri);
//    Tcl_Eval(interp, "ClearCaption");
//jing
    Tcl_VarEval(interp, "ShowCaption \"",str,"\"",0);
} 
*/

void appShowCanvasMessage(Tcl_Interp *interp, const char *str, const char *canvasName)
{
    Tcl_VarEval(interp, "ShowCanvasMessage \"",str,"\" ",canvasName, 0);
} 

void appBrushBoundaryCaption(grCanvas *canvas, int axis)
{
    //show current brush status in the message bar
    char caption[1000]="\0";
    char str[100];
    sprintf(caption,"Brush boundary (%s): ",dataset->names[axis]);
    double datay;
    datay = curr_brush->pos[axis] + curr_brush->size[axis]/2.;
    if (dataset->nominal_fields[axis] != 0) {
		int value = (int)(datay+0.5);
        const char *string = dataset->nominal_fields[axis]->MapValueToString(value);
        sprintf(str,"%s, ",string);
    } else {
        sprintf(str,"%.2lf, ", datay);
    }
    strcat(caption, str);
    datay = curr_brush->pos[axis] - curr_brush->size[axis]/2.;
    if (dataset->nominal_fields[axis] != 0) {
		int value = (int)(datay+0.5);
        const char *string = dataset->nominal_fields[axis]->MapValueToString(value);
        sprintf(str,"%s",string);
    } else {
        sprintf(str,"%.2lf",datay);
    }
    strcat(caption, str);

    appShowCanvasMessage(Togl_Interp(canvas->GetWidget()),caption, canvas->name);
}

void appShowSunburstCaption(Tcl_Interp *interp, const char *str)
{
//jing
    char stri[50];   
	strcpy(stri, "ClearSunburstCaption");
	Tcl_Eval(interp, stri);
//    Tcl_Eval(interp, "ClearCaption");
//jing
    Tcl_VarEval(interp, "ShowSunburstCaption \"",str,"\"",0);
}

// according to size
static int appSizeStructureSelectSunburst(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    int threshold = atoi(argv[1]);
    dim_reducer->SizeStructureSelectNode(threshold, true);

    grCanvas *canvas = grFindCanvas(interp,"sunburstCanvas");
    if ( canvas )
        canvas->Refresh();

    return TCL_OK;
}


static int appRadiusStructureSelectSunburst(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    double threshold = atof(argv[1]);
    dim_reducer->RadiusStructureSelectNode(threshold, true);

    grCanvas *canvas = grFindCanvas(interp,"sunburstCanvas");
    if ( canvas )
        canvas->Refresh();

    return TCL_OK;
}


static int appSetNormalStatus(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    screen_distortion->distortion_status = false;
    return TCL_OK;
}


static int appSetDistortionStatus(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    screen_distortion->distortion_status = true;
    return TCL_OK;
}


static int appResetDistortion(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    screen_distortion->Reset();
    screen_distortion->SunburstReset();
    appRefreshAllCanvas(interp);
    return TCL_OK;
}


static int appSetActiveBrush(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    int which = atoi(argv[1]);

    SetActiveBrush(which);

    appCanvasBrushHasChanged(interp);
    appRefreshAllCanvas(interp);
    return TCL_OK;
}

static int appSetBrushEnableState(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    int which = atoi(argv[1]);
//    int state = atoi(argv[2]);
    bool state;
    if ( atoi(argv[2]) )
        state = true;
    else 
        state = false;

    SetBrushEnableState(which, state);

    appCanvasBrushHasChanged(interp);
    appRefreshAllCanvas(interp);
    return TCL_OK;
}

static int appSetBrushDisplayState(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    int which = atoi(argv[1]);
//    int state = atoi(argv[2]);
    bool state;
    if ( atoi(argv[2]) )
        state = true;
    else 
        state = false;

    SetBrushDisplayState(which, state);

    appRefreshAllCanvas(interp);
    return TCL_OK;
}

static int appSetBrushBoundaryType(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    int which = atoi(argv[1]);
    int type = atoi(argv[2]);

    SetBrushBoundaryType(which,(type==0)?Brush::STEP:Brush::RAMP);
    appCanvasBrushHasChanged(interp);

    appRefreshAllCanvas(interp);
    return TCL_OK;
}

static int appSaveMainCanvasImage(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    const char *fname = argv[1];

    grCanvas *canvas = grFindCanvas(interp,"mainCanvas");
    assert(canvas);
    canvas->WriteImage(fname);

    return TCL_OK;
}

static int appGlobalBrushResize(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    const char *how = argv[1];

    if (strcasecmp(how,"max")==0) {
	curr_brush->Resize(0);
    } else
    if (strcasecmp(how,"half")==0) {
//        curr_brush->Resize(0.5);
        curr_brush->Resize(0);
        curr_brush->Resize(0.5);
    } else
    if (strcasecmp(how,"+")==0) {
        curr_brush->Resize(1.1);
    } else
    if (strcasecmp(how,"-")==0) {
        curr_brush->Resize(0.9);
    }

    appCanvasBrushHasChanged(interp);
    appRefreshAllCanvas(interp);

    return TCL_OK;
}


static int appSetClusterRadius(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    if (!dataset || !btree) return TCL_OK;

    double val = atof(argv[1]);
    if (val==hier_info->cluster_radius) return TCL_OK;

    hier_info->cluster_radius = val;

    double root_radius = btree->nodes[0].sqrt_radius;
    hierMarkContourNodes( root_radius*hier_info->cluster_radius, IS_CONTOUR0 );

    appRefreshAllCanvas(interp);

    return TCL_OK;
}

void appUpdateClusterRadiusSliders(Tcl_Interp *interp)
{
    assert(interp);
    char str[30];
    sprintf(str," %.2f %.2f ",hier_info->cluster_radius, hier_info->brushed_radius);
    Tcl_VarEval(interp, "UpdateClusterRadiusSliders ",str,0);
}

void appUpdateTreeBrushEntries(Tcl_Interp *interp)
{
    assert(interp);
    char str[500];
    sprintf(str,"%12lf %12lf",hier_info->tree_brush[0], hier_info->tree_brush[1]);
    
    Tcl_VarEval(interp,"UpdateTreeBrushes ",str,0);
}

static int appSetBrushedRadius(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    if (!dataset || !btree) return TCL_OK;

    double val = atof(argv[1]);
    if (val==hier_info->brushed_radius) return TCL_OK;

    hier_info->brushed_radius = val;

    double root_radius = btree->nodes[0].sqrt_radius;
    hierMarkContourNodes( root_radius*hier_info->brushed_radius, IS_CONTOUR1 );

    appRefreshAllCanvas(interp);

    return TCL_OK;
}


static int appSetBandsOnOff(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    if ( atoi(argv[1]) )
        hier_info->SHOW_BANDS = true;
    else 
        hier_info->SHOW_BANDS = false;
//    hier_info->SHOW_BANDS = atoi(argv[1]);

    grCanvas *canvas = grFindCanvas(interp,"mainCanvas");
    assert(canvas);
    canvas->Refresh();

    return TCL_OK;
}


static int appSetDimReductionDisagreePresent(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    bool show_two_axes;
    bool show_bands;
    bool show_wide_axes;

    if ( atoi(argv[1]) )
        show_two_axes = true;
    else 
        show_two_axes = false;

    if ( atoi(argv[2]) )
        show_bands = true;
    else 
        show_bands = false;

    if ( atoi(argv[3]) )
        show_wide_axes = true;
    else 
        show_wide_axes = false;
    
//    bool show_two_axes = atoi(argv[1]);
//    bool show_bands = atoi(argv[2]);
    if ( show_two_axes )
        dim_reduction_info->disagree_present = TWOAXES;
    else if ( show_bands )
        dim_reduction_info->disagree_present = MEANBANDS;
    else if ( show_wide_axes )
        dim_reduction_info->disagree_present = WIDEAXES;
    else
        dim_reduction_info->disagree_present = OMIT;

    grCanvas *canvas = grFindCanvas(interp,"mainCanvas");
    assert(canvas);
    canvas->Refresh();

    return TCL_OK;
}


static int appMagnify(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    grCanvas *canvas = grFindCanvas(interp,"mainCanvas");
    assert(canvas);

    MagnifyBrushRegion(canvas);

    return TCL_OK;
}

static int appDeMagnify(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    grCanvas *canvas = grFindCanvas(interp,"mainCanvas");
    assert(canvas);

    Demagnify(canvas);

    return TCL_OK;
}

static int appSetExtentScalingFactor(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    hier_info->extent_scaling_fac = atof(argv[1])/100.;
    grCanvas *canvas = grFindCanvas(interp,"mainCanvas");
    if ( canvas != NULL )
        canvas->Refresh();

    return TCL_OK;
}

static int appSetTreeBrush(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    int which = atoi(argv[2]);
    double value = atof(argv[1]);

    if ( which == 0 )
    {
        if ( value >= hier_info->tree_brush[1] )
            hier_info->tree_brush[0] = hier_info->tree_brush[1];
        else if ( value < 0 )
            hier_info->tree_brush[0] = 0;
        else
            hier_info->tree_brush[0] = value;
    }
    else
    {
        if ( value <= hier_info->tree_brush[0] )
            hier_info->tree_brush[1] = hier_info->tree_brush[0];
        else if ( value > 1 )
            hier_info->tree_brush[1] = 1;
        else
            hier_info->tree_brush[1] = value;
    }

    appUpdateTreeBrushEntries(interp);
    SetupBrushParameters();
    appRefreshAllCanvas(interp);
    
    return TCL_OK;
}

static int appSetDimReductionExtentScalingFactor(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    dim_reduction_info->extent_scaling_fac = atof(argv[1])/100.;

    appRefreshAllCanvas(interp);

    return TCL_OK;
}


static int appSetDynamicMaskingScale(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    hier_info->fade_factor = atof(argv[1]);
    grCanvas *canvas = grFindCanvas(interp,"mainCanvas");
    if ( canvas != NULL )
        canvas->Refresh();

    return TCL_OK;
}

void appCanvasMousePan(grCanvas *canvas)
{
    Vec2 motion = canvas->MapScreenToData(canvas->curr_pos) - canvas->MapScreenToData(canvas->prev_pos);
    canvas->translate = canvas->translate + motion;
//jing
    char stri[50];   
	strcpy(stri, "CanvasVertScrollCmd sync");
//    Tcl_Eval(Togl_Interp(canvas->GetWidget()),"CanvasVertScrollCmd sync");
//    Tcl_Eval(Togl_Interp(canvas->GetWidget()),"CanvasHorizScrollCmd sync");
    Tcl_Eval(Togl_Interp(canvas->GetWidget()),stri);
	strcpy(stri, "CanvasHorizScrollCmd sync");
    Tcl_Eval(Togl_Interp(canvas->GetWidget()),stri);
//jing
    canvas->Refresh();
}

void appSetupBrushStatistics(Tcl_Interp *interp)
{

    Tcl_Eval(interp,"SetupBrushStats");
}

void appRefreshGlyphPlacementDialog(Tcl_Interp *interp)
{

    Tcl_Eval(interp,"RefreshGlyphPlacement");
}

static int appGetBrushOpString(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    int op_num = atoi(argv[1])-1;
    if (op_num >= num_oper) return TCL_OK;
    Tcl_SetResult( interp, (char*) BrushOperGenerateString(atoi(argv[1])-1), TCL_STATIC );
    return TCL_OK;
}

static int appGetGlyphPlacementInfo(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    char mode[20], str[100];
    switch(flat_info->glyph_place) 
    {
    case ORIGINAL:
        sprintf(mode,"original");
        break;
    case ORDERED:
        sprintf(mode,"ordered");
        break;
    case DATA_DRIVEN:
        sprintf(mode,"data_driven");
        break;
    case DERIVED:
        sprintf(mode,"derived");
        break;
    }

    sprintf(str,"%s %d %d %d", mode, flat_info->increase, flat_info->space, flat_info->reduce_overlap);
    Tcl_SetResult( interp, str, TCL_STATIC );
    return TCL_OK;
}

static int appNewBrushOps(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    int op_num = BrushOperNew();
    char str[5];
    sprintf(str,"%d",op_num);
    Tcl_SetResult( interp, str, TCL_STATIC );

/*  if (dataset) BrushOperMarkDataset(); // Need to recolor the points
    grCanvas *canvas = grFindCanvas(interp,"mainCanvas");
    assert(canvas);
    canvas->Refresh();
*/
    return TCL_OK;
}

/*
static int appUpdataDisplays(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    appCanvasBrushHasChanged(interp);
    appRefreshAllCanvas(interp);
    return TCL_OK;
}
*/

static int appDeleteBrushOps(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    int op_num = atoi(argv[1])-1;
    BrushOperDelete(op_num);

    appCanvasBrushHasChanged(interp);
    appRefreshAllCanvas(interp);

    return TCL_OK;
}

static int appGetBrushOps(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    static char buf[10];
    strcpy(buf, "");
    BrushOperation *op = &brush_ops[atoi(argv[1])-1];

    assert(op);

    // Append the operation(s)
    if (op->oper & HIGH)
        strcat(buf, "1 ");
    else
    if (op->oper & MASK)
        strcat(buf, "0 ");
    else
        strcat(buf, "-1 ");

    if (op->oper & VALUES)
        strcat(buf, "1 ");
    else
        strcat(buf, "0 ");

    if (op->oper & AVERAGE)
        strcat(buf, "1 ");
    else
        strcat(buf, "0 ");

    Tcl_SetResult( interp, buf, TCL_STATIC );
    return TCL_OK;

}

static int appGetNumBrushes(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    BrushOperation *op = &brush_ops[atoi(argv[1])-1];
    assert(op);

    static char brushes[5]="";
    strcpy(brushes,"");
    sprintf(brushes, "%d", op->num_brush);
    Tcl_SetResult( interp, brushes, TCL_STATIC );
    return TCL_OK;
}

static int appGetBrushExpr(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    static char buf[100];
    strcpy(buf, "");
    BrushOperation *op = &brush_ops[atoi(argv[1])-1];
    int idx = atoi(argv[2])-1;
    assert(op);

    // Add a NOT if necessary
    if (op->xnot[idx])
        strcat(buf, "1 ");
    else
        strcat(buf, "0 ");

    // Add the brush number
    char str[5];
    sprintf(str,"%d ",op->brush[idx]+1);
    strcat(buf, str);

    // Add a conjunction if there are more brushes
    if (idx < op->num_brush-1) {
        switch(op->conj[idx])
        {
        case AND:
            strcat(buf, "1 ");
            break;
        case OR:
            strcat(buf, "2 ");
            break;
        case XOR:
            strcat(buf, "3 ");
            break;
        }
    }

    Tcl_SetResult( interp, buf, TCL_STATIC );
    return TCL_OK;

}

static int appFormBrushExpr(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    int cur_op = atoi(argv[1]) - 1;

    brush_ops[cur_op].num_brush= 0;

    brush_ops[cur_op].oper = 0;

    if (strcmp(argv[2], "highlight") == 0)
        brush_ops[cur_op].oper = HIGH;

    if (strcmp(argv[2], "mask") == 0)
        brush_ops[cur_op].oper = MASK;

    if (atoi(argv[3])) { BITSET(brush_ops[cur_op].oper,VALUES); }

    if (atoi(argv[4])) { BITSET(brush_ops[cur_op].oper,AVERAGE); }

    int i;
    for (i=0; i<MAXBRUSH; i++) {
        brush_ops[cur_op].xnot[i] = atoi(argv[i+5]);
    }

    for (i=0; i<MAXBRUSH; i++) {
        if (atoi(argv[i+9])) brush_ops[cur_op].num_brush++;
        brush_ops[cur_op].brush[i] = atoi(argv[i+9])-1;
    }

    for (i=0; i<MAXBRUSH-1; i++) {
        if (strcmp(argv[i+13],"and") == 0)
            brush_ops[cur_op].conj[i] = AND;

        if (strcmp(argv[i+13],"or") == 0)
            brush_ops[cur_op].conj[i] = OR;

        if (strcmp(argv[i+13],"xor") == 0)
            brush_ops[cur_op].conj[i] = XOR;

    }

    if (brush_ops[cur_op].oper != 0)
        appCanvasBrushHasChanged(interp);

    appRefreshAllCanvas(interp);

    return TCL_OK;
}


static int appLowerOperPriority(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    BrushOperLowerPriority(atoi(argv[1])-1);

    if (dataset) BrushOperMarkDataset(); // Need to recolor the points
    grCanvas *canvas = grFindCanvas(interp,"mainCanvas");
    assert(canvas);
    canvas->Refresh();
    return TCL_OK;
}

static int appRaiseOperPriority(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    BrushOperRaisePriority(atoi(argv[1])-1);

    if (dataset) BrushOperMarkDataset(); // Need to recolor the points
    grCanvas *canvas = grFindCanvas(interp,"mainCanvas");
    assert(canvas);
    canvas->Refresh();
    return TCL_OK;
}

static int appDrawBrushStatsCanvas(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    if (!dataset) return TCL_OK;
    int which = atoi(argv[1]);
    char *where = argv[2];

    Tcl_CmdInfo infoPtr;
    if (Tcl_GetCommandInfo(interp,(char*)where,&infoPtr)==0) {
        return 0;
    }
    Tk_Canvas canvas = (Tk_Canvas) infoPtr.clientData;
    assert(canvas);

    statsPlotBrushCoverage(interp,canvas,where,which);

    char str[100];
    sprintf(str,"%lf %lf",curr_brush->Min(which), curr_brush->Max(which));

    Tcl_SetResult( interp, str, TCL_STATIC );

    return TCL_OK;
}

static int appGetDatasetSummary(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    if (!dataset) {
        Tcl_SetResult( interp, "", TCL_STATIC );
        return TCL_OK;
    }

    char full_path[200];
//    realpath(dataset->datafile, full_path);
//jing
	strcpy(full_path, dataset->datafile);
//jing
    char *short_name = strrchr(full_path, '/');
    *short_name = '\0';
    short_name++;

    struct stat buf;
    stat(dataset->datafile, &buf);

    char str[1000];
    sprintf(str,"%s %s %d %d %d",short_name,full_path, int(buf.st_size), dataset->data_size, dataset->all_dims);

    Tcl_SetResult( interp, str, TCL_STATIC );

    return TCL_OK;
}

static int appGetDimensionName(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{

    if (!dataset) return TCL_OK;

    int which = atoi(argv[1]);
    if (which < 0 || which >= dataset->all_dims) {
        Tcl_SetResult( interp, "", TCL_STATIC );
        return TCL_OK;
    }

    Tcl_SetResult( interp, dataset->names[which], TCL_STATIC );

    return TCL_OK;
}

static int appGetDimensionNames(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    if (!dataset) {
        Tcl_SetResult( interp, "", TCL_STATIC );
        return TCL_OK;
    }

    char str[200];
	strcpy(str, dataset->all_names[0]);
    for ( int i = 1; i < dataset->all_dims; i++ )
	{
		strcat(str, " ");
		strcat(str, dataset->all_names[i]);
	}

    Tcl_SetResult( interp, str, TCL_STATIC );

    return TCL_OK;
}


static int appGetPrincipalNames(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    if (!dataset) {
        Tcl_SetResult( interp, "", TCL_STATIC );
        return TCL_OK;
    }

	int i, prin_num;
	char **prin_names;
	if ( dataset->dims < 3 )
		prin_num = dataset->dims;
	else
		prin_num = 3;
	prin_names = new char *[prin_num];

	char name_num[2];
	for ( i = 0; i < prin_num; i++ )
	{
		prin_names[i] = new char[20];
		strcpy(prin_names[i], "Principal_Component_");
        sprintf(name_num, "%d", i);
		strcat(prin_names[i], name_num);
	}

    char str[200];
	strcpy(str, prin_names[0]);
    for ( i = 1; i < prin_num; i++ )
	{
		strcat(str, " ");
		strcat(str, prin_names[i]);
	}

    Tcl_SetResult( interp, str, TCL_STATIC );

    return TCL_OK;
}

static int appGetFieldInfo(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    if (!dataset) {
        Tcl_SetResult( interp, "", TCL_STATIC );
        return TCL_OK;
    }

    int which = atoi(argv[1]);
    if (which < 0 || which >= dataset->all_dims) {
        Tcl_SetResult( interp, "", TCL_STATIC );
        return TCL_OK;
    }

    ARR<char*> temp_names(dataset->all_dims);
	ARR<double> temp_dim_min(dataset->all_dims);
	ARR<double> temp_dim_max(dataset->all_dims);
		
	dataset->MapDataWithoutOnOff(dataset->all_names, temp_names);
	dataset->MapDataWithoutOnOff(dataset->all_dim_min, temp_dim_min);
	dataset->MapDataWithoutOnOff(dataset->all_dim_max, temp_dim_max);

	char str[200];
    sprintf(str,"%s %lf %lf",temp_names[which], temp_dim_min[which],temp_dim_max[which]);

    Tcl_SetResult( interp, str, TCL_STATIC );

    return TCL_OK;
}

static int appGetDimensionInfo(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    if (!dataset) {
        Tcl_SetResult( interp, "", TCL_STATIC );
        return TCL_OK;
    }

    int which = atoi(argv[1]);
    if (which < 0 || which >= dataset->all_dims) {
        Tcl_SetResult( interp, "", TCL_STATIC );
        return TCL_OK;
    }
// to change? JingJing
    ARR<char*> temp_names(dataset->all_dims);
		
	dataset->MapDataWithoutOnOff(dataset->all_names, temp_names);

	char str[200];
    sprintf(str,"%s %d",temp_names[which], dataset->on[which]);

    Tcl_SetResult( interp, str, TCL_STATIC );

    return TCL_OK;
}


static int appGetClusterBrush(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    int i; 
	if ( hier_info->SHOW_BANDS )
		i = 1;
	else  
		i = 0;

    char str[200];
	sprintf(str,"%d %lf %lf %lf %lf %lf %lf",i,hier_info->cluster_radius,hier_info->brushed_radius,
        hier_info->fade_factor, 100-hier_info->extent_scaling_fac*100, hier_info->tree_brush[0], hier_info->tree_brush[1]);

    Tcl_SetResult( interp, str, TCL_STATIC );

    return TCL_OK;
}

static int appGetDimReductionToolbox(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    int i, j, k; 
            
	if ( dim_reduction_info->disagree_present == TWOAXES )
		i = 1;
	else  
		i = 0;

    if ( dim_reduction_info->disagree_present == MEANBANDS )
		j = 1;
	else  
		j = 0;

    if ( dim_reduction_info->disagree_present == WIDEAXES )
		k = 1;
	else  
		k = 0;

    char str[200];
	sprintf(str,"%d %d %d %lf",i, j, k, 100-dim_reduction_info->extent_scaling_fac*100);

    Tcl_SetResult( interp, str, TCL_STATIC );

    return TCL_OK;
}


static int appSetFieldOnOff(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    if ( dim_reducer != NULL && dim_reducer->status != NORMAL)
        return TCL_OK;

    if (!dataset) {
        Tcl_SetResult( interp, "", TCL_STATIC );
        return TCL_OK;
    }

    int which = atoi(argv[1]);
//    int state = atoi(argv[2]);
    bool state;
    if ( atoi(argv[2]) )
        state = true;
    else 
        state = false;

    dataset->SetFieldOnOff(which, state);
    appRefreshGlyphPlacementDialog(interp);

//    if (btree) hierSetMeanOnOff();

    appCanvasBrushHasChanged(interp);

    grCanvas *canvas = grFindCanvas(interp,"mainCanvas");
    assert(canvas);
    canvas->Refresh();

    Tcl_Eval(interp,"SetupDataSummary");

    Tcl_Eval(interp,"SetupDimensionOnOffReorder");

    return TCL_OK;
}

static int appReorderDimension(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    if ( dim_reducer != NULL && dim_reducer->status != NORMAL)
        return TCL_OK;

    if (!dataset) {
        Tcl_SetResult( interp, "", TCL_STATIC );
        return TCL_OK;
    }

    int which = atoi(argv[1]);
    int forward = atoi(argv[2]);

    dataset->ReorderDimension(which, forward);

	appCanvasBrushHasChanged(interp);

    Tcl_Eval(interp,"SetupDataSummary");
//jing
    Tcl_Eval(interp,"SetupDimensionOnOffReorder");

    Tcl_Eval(interp,"SetupGlyphKeyDialog");

    Tcl_Eval(interp,"SetupDimStackKeyDialog");

    Tcl_Eval(interp,"SetupBrushStats");

    Tcl_Eval(interp,"SetupClusterBrush");

//    Tcl_Eval(interp,"SetupDimReductionToolbox");
//jing
//    Tcl_Eval(interp,"SetupDependentDimensionsMenu");

    appRefreshAllCanvas(interp);
/*

    grCanvas *canvas = grFindCanvas(interp,"mainCanvas");
    assert(canvas);
    canvas->Refresh();
*/
    return TCL_OK;
}


static int appGlyphPlacementSort(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    if (!dataset) {
        Tcl_SetResult( interp, "", TCL_STATIC );
        return TCL_OK;
    }

    char* name = argv[1];

    //    int increase = atoi(argv[2]);
    bool increase;
    if ( atoi(argv[2]) )
        increase = true;
    else
        increase = false;

    //    int space = atoi(argv[3]);
    bool space;
    if ( atoi(argv[3]) )
        space = true;
    else 
        space = false;

	bool success = false;
	int dimnumber;
	for ( int i = 0; i < dataset->all_dims; i++ )
	{
		if ( strcmp(name, dataset->all_names[i]) == 0 )
		{
			success = true;
			dimnumber = i;
			break;
		}
	}
	
	if ( success )
	{
        flat_info->glyph_place = ORDERED;
        flat_info->increase = increase;
        flat_info->space  = space;

		if ( space )
			dataset->Placement_Sort_Space_Glyph(dimnumber, increase);
		else
			dataset->Placement_Sort_Glyph(dimnumber, increase);
	    appRefreshAllCanvas(interp);
	}
    return TCL_OK;
}


static int appSetSunburstStatus(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    if ( dim_reducer != NULL )
        dim_reducer->SetStatus(argv[1]);
    appRefreshAllCanvas(interp);
    return TCL_OK;
}


// NEW - zfc
static int appGlyphShapeOriginal(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    if (!dataset) {
        Tcl_SetResult( interp, "", TCL_STATIC );
        return TCL_OK;
    }

    dataset->Shape_Original_Glyph();
    appRefreshAllCanvas(interp);
    return TCL_OK;
}
// NEW - zfc

// NEW - zfc
static int appGlyphShapeNew(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    if (!dataset) {
        Tcl_SetResult( interp, "", TCL_STATIC );
        return TCL_OK;
    }

    dataset->Shape_New_Glyph();
    appRefreshAllCanvas(interp);
    return TCL_OK;
}
// NEW - zfc


static int appGlyphPlacementOriginal(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    if (!dataset) {
        Tcl_SetResult( interp, "", TCL_STATIC );
        return TCL_OK;
    }

    int space = atoi(argv[1]);
	if ( space )
		dataset->Placement_Original_Space_Glyph();
	else 
		dataset->Placement_Original_Glyph();

    flat_info->glyph_place = ORIGINAL;
    flat_info->space = space;

    appRefreshAllCanvas(interp);

    return TCL_OK;
}

static int appGlyphPlacementDataDriven(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    if (!dataset) {
        Tcl_SetResult( interp, "", TCL_STATIC );
        return TCL_OK;
    }

    char* name1 = argv[1];
    char* name2 = argv[2];
    int shift = atoi(argv[3]);

	bool success1 = false;
	bool success2 = false;

	int xdimnumber, ydimnumber;
	for ( int i = 0; i < dataset->all_dims; i++ )
	{
		if ( strcmp(name1, dataset->all_names[i]) == 0 )
		{
			success1 = true;
			xdimnumber = i;
		}
		if ( strcmp(name2, dataset->all_names[i]) == 0 )
		{
			success2 = true;
			ydimnumber = i;
		}
	}
	
	if ( success1 && success2 )
	{
        flat_info->glyph_place = DATA_DRIVEN;
        flat_info->reduce_overlap = shift;

        dataset->Placement_DataDriven_Glyph(xdimnumber ,ydimnumber);
		if ( shift )
		{
			dataset->Placement_Shift_Glyph();
		}
	    appRefreshAllCanvas(interp);
	}

    return TCL_OK;
}


static int appGlyphPlacementDerived(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    if (!dataset) {
        Tcl_SetResult( interp, "", TCL_STATIC );
        return TCL_OK;
    }

	int i, prin_num;
	char **prin_names;
	if ( dataset->dims < 3 )
		prin_num = dataset->dims;
	else
		prin_num = 3;
	prin_names = new char *[prin_num];

	char name_num[2];
	for ( i = 0; i < prin_num; i++ )
	{
		prin_names[i] = new char[20];
		strcpy(prin_names[i], "Principal_Component_");
        sprintf(name_num, "%d", i);
		strcat(prin_names[i], name_num);
	}
	
	char* name1 = argv[1];
    char* name2 = argv[2];
    int shift = atoi(argv[3]);


	bool success1 = false;
	bool success2 = false;

	int xdimnumber, ydimnumber;
	for ( i = 0; i < prin_num; i++ )
	{
		if ( strcmp(name1, prin_names[i]) == 0 )
		{
			success1 = true;
			xdimnumber = i + dataset->all_dims;
		}
		
		if ( strcmp(name2, prin_names[i]) == 0 )
		{
			success2 = true;
			ydimnumber = i + dataset->all_dims;
		}

	}

	for ( i = 0; i < dataset->all_dims; i++ )
	{
		if ( strcmp(name1, dataset->all_names[i]) == 0 )
		{
			success1 = true;
			xdimnumber = i;
		}
		
		if ( strcmp(name2, dataset->all_names[i]) == 0 )
		{
			success2 = true;
			ydimnumber = i;
		}
	}
	
	if ( success1 && success2 )
	{
        flat_info->glyph_place = DERIVED;
        flat_info->reduce_overlap = shift;
		dataset->Placement_Derived_Glyph(xdimnumber ,ydimnumber);
		if ( shift )
		{
			dataset->Placement_Shift_Glyph();
		}
	    appRefreshAllCanvas(interp);
	}

    return TCL_OK;
}

static int appGetCanvasViewParameters(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    grCanvas *canvas = grFindCanvas(interp, argv[1]);
    assert(canvas);

    Vec2 percent;
    percent.X = 1.0 / canvas->zoom.X;
    percent.Y = 1.0 / canvas->zoom.Y;

    Vec2 org;
    org.X = -canvas->translate.X;
    org.Y = -canvas->translate.Y;

    //if (canvas->origin_at_lower_left) org.Y = 1.0 + canvas->translate.Y - percent.Y;

    char str[100];
    sprintf(str,"%lf %lf %lf %lf",org.X,org.Y,percent.X,percent.Y);

    Tcl_SetResult( interp, str, TCL_STATIC );
    return TCL_OK;
}

static int appSetViewScrollTo(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    double xorg = atof(argv[2]);
    double yorg = atof(argv[3]);

    grCanvas *canvas = grFindCanvas(interp, argv[1]);
    assert(canvas);

    //if (canvas->origin_at_lower_left) yorg = 1.0 - yorg - 1.0/canvas->zoom.Y;

    canvas->translate.X = -xorg;
    canvas->translate.Y = -yorg;

    canvas->Refresh();

    return TCL_OK;
}

static int appSetDimensionReduction(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    int enable = atoi(argv[1]);

    dim_reduction_info->Enable(enable);

    return TCL_OK;
}

static int appQueryGlyphKey(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    if (!dataset) 
    {
        Tcl_SetResult( interp, "", TCL_STATIC );
        return TCL_OK;
    }

    int which = atoi(argv[1]);
    if (which < 0 || which >= dataset->dims)
    {
        Tcl_SetResult( interp, "", TCL_STATIC );
        return TCL_OK;
    }

    // Compute text strings and place pointers into keylist
    //
/*    char key_text[500] = "\0";
    for (int i = 0;i < dataset->dims;i++) {
        char str[100];
        sprintf(str, "%s: %.1f degrees\n",dataset->names[i],i*360./dataset->dims);
        strcat(key_text,str);
    }
*/
   	char str[200];
    sprintf(str, "%s: %.1f degrees\n",dataset->names[which], which*360./dataset->dims);

    Tcl_SetResult( interp, str, TCL_STATIC );
    return TCL_OK;
}

/*
static int appQueryDimStackKey(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    if (!dataset) return TCL_OK;

    char key_text[500] = "\0";
    char str[100];

    // Do horizontal dimensions, then vertical, slow speed to high
    //
    sprintf(str, "Horizontal Dimensions: outer to inner\n");
    strcat(key_text,str);

    int i;
    for (i = 0;i < dataset->dims;i= i+2) {
        sprintf(str, "   %s: cardinality %d\n",dataset->names[i], dataset->cardinality[i]);
        strcat(key_text,str);
    }

    sprintf(str, "Vertical Dimensions: outer to inner\n");
    strcat(key_text,str);

    for (i = 1;i < dataset->dims;i= i+2) {
        sprintf(str, "   %s: cardinality %d\n",dataset->names[i], dataset->cardinality[i]);
        strcat(key_text,str);
    }

    Tcl_SetResult( interp, key_text, TCL_STATIC );
    return TCL_OK;
}
*/

static int appQueryDimStackKey(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    if (!dataset) 
    {
        Tcl_SetResult( interp, "", TCL_STATIC );
        return TCL_OK;
    }

    int which = atoi(argv[1]);
    if (which < 0 || which >= dataset->dims)
    {
        Tcl_SetResult( interp, "", TCL_STATIC );
        return TCL_OK;
    }

   	char str[200];
    sprintf(str, "   %s: cardinality %d\n",dataset->names[which], dataset->cardinality[which]);

    Tcl_SetResult( interp, str, TCL_STATIC );
    return TCL_OK;
}


/*
static int appRegisterCanvas(Tcl_Interp *interp, const char *canvas_name, const char *type)
{
    grCanvas *canvas = grFindCanvas(interp,canvas_name);
    assert(canvas);
//    canvas->SetDefaultCursor();

    if ( canvas->display)
    {
        delete canvas->display;
        canvas->display = 0;
    }

    if (strcmp(type,"parcoord")==0) 
    {
        CFlatParcoord *dis = new CFlatParcoord(flat_info);
        canvas->RegisterDisplay(dis);
		strcpy(oldType, type);   
	} 
    else if (strcmp(type,"scatter")==0) 
    {
      	CFlatScatter *dis = new CFlatScatter(flat_info);
        canvas->RegisterDisplay(dis);
		strcpy(oldType, type);
    } 
    else if (strcmp(type,"glyphs")==0) 
    {
      	CFlatGlyph *dis = new CFlatGlyph(flat_info);
        canvas->RegisterDisplay(dis);
		strcpy(oldType, type);
    }
    else if (strcmp(type,"dimstack")==0) 
    {
      	CFlatDimstack *dis = new CFlatDimstack(flat_info);
        canvas->RegisterDisplay(dis);
		strcpy(oldType, type);
    } 
    else if (strcmp(type,"hierarchical")==0) 
    {

        if (dataset && btree==0) {
            int N = strlen(dataset->datafile);
            char* cf_file = new char[N+1];
            strcpy(cf_file,dataset->datafile);
            strcpy(&cf_file[N-4],".cf");

            Tcl_VarEval(interp,"LoadClusterFile ",dataset->datafile," ",cf_file,0);
			delete cf_file;
		}
        if ( strcmp(oldType, "scatter") == 0 )
        {
      	    CHierScatter *dis = new CHierScatter(hier_info);
            canvas->RegisterDisplay(dis);
        }
        else if ( strcmp(oldType, "glyphs") == 0 )
        {
      	    CHierGlyph *dis = new CHierGlyph(hier_info);
            canvas->RegisterDisplay(dis);
        }
        else if ( strcmp(oldType, "dimstack") == 0 )
        {
      	    CHierDimstack *dis = new CHierDimstack(hier_info);
            canvas->RegisterDisplay(dis);
        }
        else
        {
      	    CHierParcoord *dis = new CHierParcoord(hier_info);
            canvas->RegisterDisplay((CHierDisplay *)dis);
        }

    } 
    else if (strcmp(type,"cfNav")==0) 
    {
      	CHierNav *dis = new CHierNav(hier_info);
        canvas->RegisterDisplay(dis);
    } 
    else if (strcmp(type,"cfHist")==0) 
    {
      	CHierHist *dis = new CHierHist(hier_info);
        canvas->RegisterDisplay(dis);
    } 
    else if (strcmp(type,"minimap")==0) 
    {
      	CParcoordTool *dis = new CParcoordTool(flat_info);
        canvas->RegisterDisplay(dis);
    } 
    else if (strcmp(type,"treemap")==0) 
    {
      	CHierTreemap *dis = new CHierTreemap(hier_info);
        canvas->RegisterDisplay(dis);
    } 
    else if (strcmp(type,"glyphtoolbox")==0) 
    {
      	CGlyphTool *dis = new CGlyphTool(flat_info);
        canvas->RegisterDisplay(dis);
    } 
    else if (strcmp(type,"stacktoolbox")==0) 
    {
      	CDimstackTool *dis = new CDimstackTool(flat_info);
        canvas->RegisterDisplay(dis);
    } 
    else if (strcmp(type,"sunburst")==0) 
    {
      	CSunburstDimDisplay *dis = new CSunburstDimDisplay();
//      	CSunburstDataDisplay *dis = new CSunburstDataDisplay();
        canvas->RegisterDisplay(dis);
    } 
    else 
    {
//        cerr << "### Undefined display mode: \"" << type << "\".\n";
    }


    canvas->Refresh();

    return TCL_OK;
}
*/


static int appRegisterCanvas(Tcl_Interp *interp, const char *canvas_name, const char *type)
{
    grCanvas *canvas = grFindCanvas(interp,canvas_name);
    assert(canvas);
    canvas->SetDefaultCursor();

    if ( canvas->display)
    {
        delete canvas->display;
        canvas->display = 0;
    }

    if (strcmp(type,"pa")==0) 
    {
        CFlatParcoord *dis = new CFlatParcoord(flat_info);
        canvas->RegisterDisplay(dis);
	} 
    else if (strcmp(type,"sc")==0) 
    {
      	CFlatScatter *dis = new CFlatScatter(flat_info);
        canvas->RegisterDisplay(dis);
    } 
    else if (strcmp(type,"st")==0) 
    {
      	CFlatGlyph *dis = new CFlatGlyph(flat_info);
        canvas->RegisterDisplay(dis);
    }
    else if (strcmp(type,"di")==0) 
    {
      	CFlatDimstack *dis = new CFlatDimstack(flat_info);
        canvas->RegisterDisplay(dis);
    } 
    else if ( strcmp(type,"hpa")==0 || strcmp(type,"hsc")==0 || strcmp(type,"hst")==0 || strcmp(type,"hdi")==0 ) 
    {

        if (dataset && btree==0) {
            int N = strlen(dataset->datafile);
            char* cf_file = new char[N+1];
            strcpy(cf_file,dataset->datafile);
            strcpy(&cf_file[N-4],".cf");

            Tcl_VarEval(interp,"LoadClusterFile ",dataset->datafile," ",cf_file,0);
			delete cf_file;
		}
        if ( strcmp(type,"hpa")==0 )
        {
      	    CHierParcoord *dis = new CHierParcoord(hier_info);
            canvas->RegisterDisplay(dis);
        }
        else if ( strcmp(type,"hsc")==0 )
        {
            CHierScatter *dis = new CHierScatter(hier_info);
            canvas->RegisterDisplay(dis);
        }
        else if ( strcmp(type,"hst")==0 )
        {
            CHierGlyph *dis = new CHierGlyph(hier_info);
            canvas->RegisterDisplay(dis);
        }
        else if ( strcmp(type,"hdi")==0 )
        {
            CHierDimstack *dis = new CHierDimstack(hier_info);
            canvas->RegisterDisplay(dis);
        }
    } 
    else if (strcmp(type,"cfNav")==0) 
    {
      	CHierNav *dis = new CHierNav(hier_info);
        canvas->RegisterDisplay(dis);
    } 
    else if (strcmp(type,"cfHist")==0) 
    {
      	CHierHist *dis = new CHierHist(hier_info);
        canvas->RegisterDisplay(dis);
    } 
    else if (strcmp(type,"minimap")==0) 
    {
      	CParcoordTool *dis = new CParcoordTool(flat_info);
        canvas->RegisterDisplay(dis);
    } 
    else if (strcmp(type,"treemap")==0) 
    {
      	CHierTreemap *dis = new CHierTreemap(hier_info);
        canvas->RegisterDisplay(dis);
    } 
    else if (strcmp(type,"glyphtoolbox")==0) 
    {
      	CGlyphTool *dis = new CGlyphTool(flat_info);
        canvas->RegisterDisplay(dis);
    } 
    else if (strcmp(type,"stacktoolbox")==0) 
    {
      	CDimstackTool *dis = new CDimstackTool(flat_info);
        canvas->RegisterDisplay(dis);
    } 
    else if (strcmp(type,"sunburst")==0) 
    {
      	CSunburstDimDisplay *dis = new CSunburstDimDisplay();
//      	CSunburstDataDisplay *dis = new CSunburstDataDisplay();
        canvas->RegisterDisplay(dis);
    } 
    else 
    {
//        cerr << "### Undefined display mode: \"" << type << "\".\n";
    }


    canvas->Refresh();

    return TCL_OK;
}


static int appUnRegisterCanvas(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    grCanvas *canvas = grFindCanvas(interp,argv[1]);
    assert(canvas);

    if ( canvas->display)
    {
        delete canvas->display;
        canvas->display = 0;
    }

    return TCL_OK;
}


static int appRegisterCanvas(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    return appRegisterCanvas(interp,argv[1],argv[2]);
}

static int appModeSelect(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    const char *what = argv[1];

    appRegisterCanvas(interp, "mainCanvas", what);
    appRefreshAllCanvas(interp);

    return TCL_OK;
}

static int appCloseOkcFile(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    if (dataset)
	{
		delete dataset->basex;
		delete dataset->basey;
		delete dataset;
	
	}

    dataset = 0;

    hierDeleteClusterTree();

    if ( dim_reducer != NULL )
    {
        delete dim_reducer;
        dim_reducer = NULL;
    }
    
    Tcl_Eval(interp,"SetupDataSummary");

    Tcl_Eval(interp,"SetupDimensionOnOffReorder");
//jing
    Tcl_Eval(interp,"SetupGlyphKeyDialog");
    
    Tcl_Eval(interp,"SetupDimStackKeyDialog");

    Tcl_Eval(interp,"::.glyphPlace::SetupGlyphPlacementDialog");

    Tcl_Eval(interp,"::.dissimilarityDisplay::SetupDissimilarityDisplayDialog");
    //Tcl_Eval(interp,"SetupBrushStats");

//jing
    appRefreshAllCanvas(interp);

    return TCL_OK;
}

//new change
static int appGetDefaultFileName(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    Tcl_SetResult( interp, default_file_name, TCL_STATIC );

    return TCL_OK;
}


static int appLoadOkcFile(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    const char *what = argv[1];
    appCloseOkcFile(clientData,interp,argc,argv);

    screen_distortion->Reset();
	hier_info->Reset();
    flat_info->Reset();
    dim_reduction_info->Reset();

    dataset = new okcdata;
    dataset->Read(what);

    InitBrushSet();
    BrushOperListInit();
    BrushOperMarkDataset();

    Tcl_Eval(interp,"ResetBrushes");

    Tcl_Eval(interp,"SetupDataSummary");

    Tcl_Eval(interp,"SetupDimensionOnOffReorder");
//jing
    Tcl_Eval(interp,"SetupGlyphKeyDialog");

    Tcl_Eval(interp,"SetupDimStackKeyDialog");

    Tcl_Eval(interp,"SetupBrushStats");

    Tcl_Eval(interp,"SetupClusterBrush");

    Tcl_Eval(interp,"::.dissimilarityDisplay::SetupDissimilarityDisplayDialog");

    Tcl_Eval(interp,"SetupGlyphPlacement");

    Tcl_Eval(interp,"::.glyphPlace::SetupGlyphPlacementDialog");

//    Tcl_Eval(interp,"SetupDependentDimensionsMenu");

    appRefreshAllCanvas(interp);
    
    return TCL_OK;
}


static int appOnlineClusterOkcFile(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    const char *what = argv[1];

    Tcl_Eval(interp,"RaiseWaitDialog");
    OnlineClusterOkcFileToCgFile(what, 100, true);
    Tcl_Eval(interp,"CloseWaitDialog");

/*    if (strcmp(what, dataset->datafile) )
    {
        screen_distortion->Reset();
	    hier_info->Reset();
        dim_reduction_info->Reset();
    }
*/    
    return TCL_OK;
}


static int appSaveBrushedOkcFile(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    const char *what = argv[1];

    dataset->WriteBrushed(what);

//    appRefreshAllCanvas(interp);
    return TCL_OK;
}

static const char *interface_item_names[] = {
                    "background",
                    "text",
                    "data",
                    "highlight1",
                    "highlight2",
                    "highlight3",
                    "highlight4",
                    "overlap",
                    "paint",
                    "grid1",
                    "grid2",
                    "grid3",
                    "grid4",
                    "stat1",
                    "stat2",
                    "brush1",
                    "brush2",
                    "brush3",
                    "brush4",
                    "sbb"
                };

static int appQueryInterfaceColor(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    const char *what = argv[1];
    unsigned int col;

    for (int i=0;i<NUM_INTERFACE_ITEM;i++) {
        if (strcmp(what,interface_item_names[i])==0) {
            col = interface_color[i];

            char str[100];
            sprintf(str,"#%06x",col);

            Tcl_SetResult( interp, str, TCL_STATIC );
            return TCL_OK;
        }
    }

//    cerr << "Wrong interface item query: " << what << "\n";
    exit(-1);
    return TCL_OK;
}

static int appSetInterfaceColor(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
    const char *what = argv[1];
    const char *cstr = argv[2];

    unsigned int col;
    sscanf(cstr+1,"%x",&col);

    for (int i=0;i<NUM_INTERFACE_ITEM;i++) {
        if (strcmp(what,interface_item_names[i])==0) {

            interface_color[i] = col;

            if (dataset) BrushOperMarkDataset(); // Need to recolor the points

            return TCL_OK;
        }
    }

//    cerr << "Wrong interface item query: " << what << "\n";
    exit(-1);
    return TCL_OK;
}

//not used in new release
static int appMainInit(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
//    cout << "--- appMainInit\n";
//    int result = Tcl_Eval(interp,"InitMainMisc");
//    cout << "--- End appMainInit\n";
//    assert(result == TCL_OK);

//    appRegisterCanvas(interp,"structBrushCanvas","cfNav");
//    appRegisterCanvas(interp,"sunburstCanvas","sunburst");
//    appRegisterCanvas(interp,"histoCanvas","cfHist");
//    appRegisterCanvas(interp,"minimapCanvas","minimap");
//    appRegisterCanvas(interp,"treemapCanvas","treemap");
//    appRegisterCanvas(interp,"glyphToolboxCanvas","glyphtoolbox");
//    appRegisterCanvas(interp,"stackToolboxCanvas","stacktoolbox");

    return TCL_OK;
}

static int InitApplication(Tcl_Interp *interp)
{
    assert(interp);
    // Initialize TCL, TK, and TOGL.
    //
    if (Tcl_Init(interp) == TCL_ERROR) return TCL_ERROR;
    if (Tk_Init(interp) == TCL_ERROR) return TCL_ERROR;
    if (Togl_Init(interp) == TCL_ERROR) return TCL_ERROR;

    // Application UI Tcl File
    Tcl_SetVar( interp, "tcl_rcFileName", (char*) interface_file, TCL_GLOBAL_ONLY );

    // Sets up a function where we can startup our application
    //
    Togl_CreateFunc( grCanvas::grInitCanvas );
    Togl_DisplayFunc( grCanvas::grDisplayEvent );
    Togl_ReshapeFunc( grCanvas::grReshapeEvent );
    Togl_DestroyFunc( grCanvas::grDestroyCanvas );

    // Setup C hooks to Tk interface
    //
    #define ADD_COMMAND(X) Tcl_CreateCommand(interp, "" #X "", X, 0, 0);

    ADD_COMMAND(appMainInit);
    ADD_COMMAND(appMainCanvasRefresh);
    ADD_COMMAND(appRefreshAllCanvas);
    ADD_COMMAND(appModeSelect);
    ADD_COMMAND(appLoadOkcFile);
    ADD_COMMAND(appOnlineClusterOkcFile);
    ADD_COMMAND(appSaveBrushedOkcFile);
    ADD_COMMAND(appCloseOkcFile);
    ADD_COMMAND(appQueryInterfaceColor);
    ADD_COMMAND(appSetInterfaceColor);
    ADD_COMMAND(appSetCanvasZoom);
    ADD_COMMAND(appSetCanvasZoomOneDirection);
    ADD_COMMAND(appGetCanvasViewParameters);
    ADD_COMMAND(appSetViewScrollTo);
    ADD_COMMAND(appGetDatasetSummary);
    ADD_COMMAND(appQueryGlyphKey);
    ADD_COMMAND(appSetDimensionReduction);
    ADD_COMMAND(appQueryDimStackKey);
    ADD_COMMAND(appGetFieldInfo);
    ADD_COMMAND(appGetDimensionInfo);
    ADD_COMMAND(appGetDimensionNames);
    ADD_COMMAND(appGetPrincipalNames);
    ADD_COMMAND(appGetClusterBrush);
    ADD_COMMAND(appGetDimReductionToolbox);
    ADD_COMMAND(appSetFieldOnOff);
    //new change
    ADD_COMMAND(appGetDefaultFileName);
    ADD_COMMAND(appReorderDimension);
    ADD_COMMAND(appGlyphPlacementSort);
    ADD_COMMAND(appGlyphPlacementOriginal);
    ADD_COMMAND(appSetSunburstStatus);
    //NEW - zfc
    ADD_COMMAND(appGlyphShapeOriginal);
    ADD_COMMAND(appGlyphShapeNew);
    //NEW - zfc
    ADD_COMMAND(appGlyphPlacementDataDriven);
    ADD_COMMAND(appGlyphPlacementDerived);
    ADD_COMMAND(appDrawBrushStatsCanvas);
    ADD_COMMAND(appSetBandsOnOff);
    ADD_COMMAND(appSetDimReductionDisagreePresent);
    ADD_COMMAND(appMagnify);
    ADD_COMMAND(appDeMagnify);
    ADD_COMMAND(appSetClusterRadius);
    ADD_COMMAND(appSetBrushedRadius);
    ADD_COMMAND(appSetExtentScalingFactor);
    ADD_COMMAND(appSetDimReductionExtentScalingFactor);
    ADD_COMMAND(appSetTreeBrush);
    ADD_COMMAND(appSetDynamicMaskingScale);
    ADD_COMMAND(appGlobalBrushResize);
    ADD_COMMAND(appSetBrushEnableState);
    ADD_COMMAND(appSetBrushDisplayState);
    ADD_COMMAND(appSetBrushBoundaryType);
    ADD_COMMAND(appSetActiveBrush);
    ADD_COMMAND(appGetDimensionName);
    ADD_COMMAND(appDependentDimensionHasChanged);
    ADD_COMMAND(appSaveMainCanvasImage);
    ADD_COMMAND(appRegisterCanvas);
    ADD_COMMAND(appUnRegisterCanvas);
    ADD_COMMAND(appSetDoubleBuffer);
    ADD_COMMAND(appNewBrushOps);
    ADD_COMMAND(appDeleteBrushOps);
    ADD_COMMAND(appFormBrushExpr);
    ADD_COMMAND(appGetBrushOpString);
    ADD_COMMAND(appRaiseOperPriority);
    ADD_COMMAND(appLowerOperPriority);
    ADD_COMMAND(appGetBrushOps);
    ADD_COMMAND(appGetNumBrushes);
    ADD_COMMAND(appGetBrushExpr);
//  ADD_COMMAND(appUpdataDisplays);
    ADD_COMMAND(appSetupDataValuesDialog);
    ADD_COMMAND(appSetNormalStatus);
    ADD_COMMAND(appSetDistortionStatus);
    ADD_COMMAND(appResetDistortion);
    ADD_COMMAND(appSizeStructureSelectSunburst);
    ADD_COMMAND(appRadiusStructureSelectSunburst);
    ADD_COMMAND(appGetCanvasZoomOneDirection);
    ADD_COMMAND(appGetGlyphPlacementInfo);

    /* Jing SID */
	ADD_COMMAND(appConnectDatabase);
	ADD_COMMAND(appDisconnectDatabase);
	ADD_COMMAND(appSetBackend);
	ADD_COMMAND(appStartBackendDemo);
    /* SID */
    ADD_COMMAND(appSetPrefetcher);
    ADD_COMMAND(appSetBrushSemantic);
    ADD_COMMAND(appSetPrefetchStrategy);
    ADD_COMMAND(appSaveActiveSet);
    ADD_COMMAND(appRegisterChange);
    ADD_COMMAND(appTest);
    ADD_COMMAND(appStartPrefetcher);
    ADD_COMMAND(appStopPrefetcher);
    ADD_COMMAND(appDisplayTime);

    appInitGlobals();

    return TCL_OK;
}

//ofstream LOGFP("LOG");

int main( int argc, char **argv )
{

    
//LOG("XmdvTool Started in main().");

    // Search for the Tk/Tcl interface file.
    // Assumes interface file is named <executable>.tcl
    //
#ifdef _WIN32
//    setenv("TCL_LIBRARY","./LIB/TCL8.0",1);
//jing
	_putenv("TCL_LIBRARY=./wintcl/lib/tcl8.1");
    strcpy(interface_file,"XmdvTool.tcl");
#else
	putenv("TCL_LIBRARY=../lib/tcl/lib/tcl8.1");
//    realpath(argv[0],interface_file);
    strcpy(interface_file,"XmdvTool.tcl");
#endif
    struct stat buf;
    int exists = stat(interface_file,&buf);
    if (exists!=0) {
//        cerr << "Missing Interface Definition file: \""<<interface_file<<"\".\n";
        exit(-1);
    }

    /* SID */
    if ( backend )
		db_connect_to_database("xmdv@kenny.wpi.edu", "xmdv");
    

    screen_distortion = new CScreenDistortion();
    flat_info = new CFlatDisplayInformation(); 
    hier_info = new CHierDisplayInformation(); 
    dim_reduction_info = new CDimReductionDisplayInformation();

	histMgmt = new HistMgmt();	//YK
 //new change
    if ( argc > 1 ) 
    {
        default_file_name = argv[1];
        argc --;
    }
    else 
    {
        default_file_name = new char[20];
        strcpy(default_file_name, "../data/iris.okc");
    }

    Tk_Main( argc, argv, InitApplication);
    assert(0); // We should never get here.
    return 0;
}
